-- Notice that we're using the `marker` and `isAutoTrigger` parameters here, followed by our own parameter `customInput`.
function MoW_hideMarker(marker, isAutoTrigger, guid)
	local markers_to_hide = World:PathablesByGuid(guid)
	for _, marker_to_hide in ipairs(markers_to_hide) do
		if isAutoTrigger then        
			marker_to_hide.InGameVisibility = false
			marker_to_hide.MiniMapVisibility = false
			marker_to_hide.MapVisibility = false
			marker_to_hide.TriggerRange = 0
		end
	end
end

function MoW_extendMarkerFade(marker, isAutoTrigger, guid, Near, Far)
	Debug:Print("Extend marker fade begins...")
	local markers_to_show = World:PathablesByGuid(guid)
	Debug:Print("The content of markers_to_show :: " .. markers_to_show)
	for _, marker_to_show in ipairs(markers_to_show) do
		Debug:Print("      looping :D")
		if isAutoTrigger then        
			marker_to_show.FadeFar = Far
			marker_to_show.FadeNear = Near
		end
	end
	Debug:Print("Extend marker fade ends...")
end

function MoW_resetSelfFade(marker, isAutoTrigger)
	if isAutoTrigger then        
		marker.FadeFar = 375
		marker.FadeNear = 300
	end
end

function MoW_resetMarkerFade(marker, isAutoTrigger, guid)
	local markers_to_show = World:PathablesByGuid(guid)
	for _, marker_to_show in ipairs(markers_to_show) do
		if isAutoTrigger then        
			marker_to_show.FadeFar = 375
			marker_to_show.FadeNear = 300
		end
	end
end

function MoW_resetCurrentMarkerFadeExtentMarkerGUID(marker, isAutoTrigger, guid, Near, Far)
	local markers_to_show = World:PathablesByGuid(guid)
	for _, marker_to_show in ipairs(markers_to_show) do
		if isAutoTrigger then
			-- Reset to default Fade for triggered marker
			marker.FadeFar = 375
			marker.FadeNear = 300		
			-- Extend Fade for guid marker
			marker_to_show.FadeFar = Far
			marker_to_show.FadeNear = Near
		end
	end
end

function MoW_showMarker(marker, isAutoTrigger, guid)
	local markers_to_show = World:PathablesByGuid(guid)
	for _, marker_to_show in ipairs(markers_to_show) do
		if isAutoTrigger then        
			marker_to_show.InGameVisibility = true
			marker_to_show.MiniMapVisibility = true
			marker_to_show.MapVisibility = true
			marker_to_show.TriggerRange = 2
		end
	end
end

function MoW_hide_show_marker(marker, isAutoTrigger, guidhide, guidshow)
	MoW_hideMarker(marker, isAutoTrigger, guidhide)
	MoW_showMarker(marker, isAutoTrigger, guidshow)
end


function MoW_hideTrail(marker, isAutoTrigger, guid)
	local trails_to_hide = World:TrailByGuid(guid)
	for _, trail_to_hide in ipairs(trails_to_hide) do
		if isAutoTrigger then        
			trail_to_hide.InGameVisibility  = false
			trail_to_hide.MiniMapVisibility = false
			trail_to_hide.MapVisibility = false
		end
	end
end

function MoW_showTrail(marker, isAutoTrigger, guid)
	local trails_to_show = World:TrailByGuid(guid)
	for _, trail_to_show in ipairs(trails_to_show) do
		if isAutoTrigger then
			trail_to_show.InGameVisibility  = true
			trail_to_show.MiniMapVisibility = true
			trail_to_show.MapVisibility = true
		end
	end
end

function MoW_hide_show_trail(marker, isAutoTrigger, guidhide, guidshow)
	MoW_hideTrail(marker, isAutoTrigger, guidhide)
	MoW_showTrail(marker, isAutoTrigger, guidshow)
end