MoW.storage = {
    --These are the default values
    firstLaunch = "true",
}

Debug:Watch("MoW_Storage", MoW.storage)

-- Load defaults on startup
for key, _ in pairs(MoW.storage) do
    local storedValue = Storage:ReadValue("mow", key)
    if (storedValue ~= nil) then
        MoW.storage[key] = storedValue
    end
end

-- Saves the the value into storage
function MoW_SaveValue(key, value)
    Storage:UpsertValue("mow", key, tostring(value))
    MoW.storage[key] = value
end

-- Returns the boolean value of the stored keys string value
function MoW_GetBool(key)
    if (MoW.storage[key] == "true") then return true
    else return false end
end

-- Toggles the boolean value of the given setting
function MoW_ToggleStorage(key)
    if (MoW_GetBool(key)) then
        MoW_SaveValue(key, "false")
    else
        MoW_SaveValue(key, "true")
    end
end