-- Constants
local MARKERS_IN_CIRCLE = 2
local MARKER_DISTANCE_FROM_PLAYER = 10
local INFO_RANGE = 4
local MARKER_CATEGORY = "mow.scripts.tutorial"
local MARKER_CATALOG = {
    {
        info = {
            "[1/12] BIENVENUE DANS LE MOUVEMENT SUR LE MONDE ! Aussi connu de son petit nom : le MoW.\n\nSi vous êtes ici, c'est que vous commencez probablement un voyage captivant à travers la Tyrie (et au-delà) ! Ces premiers marqueurs de tutoriel vous aideront à comprendre comment utiliser le guide et vous donneront quelques bases pour survivre dans ce monde sauvage que vous allez explorer.\n\nVous pouvez passer au marqueur suivant en appuyant sur la touche d'intéraction à configurer dans Blish-HUD (''F'' par défaut).",
            "[2/12] Ce guide vous propose une façon différente d’explorer les régions de Guild Wars 2, à travers les événements dynamiques, les dialogues cachés et les secrets de chaque zone.",
            "[3/12] Le guide a été créé parce que les cartes de Tyrie sont pleines de vie !\n\nLe monde bouge, les PNJ parlent, et vous... Bon, vous vous battez... Mais c'est bien aussi, hein !\n\nQuoi qu'il en soit, beaucoup de choses passent inaperçues. Le MoW vous aide à en voir le plus possible !",
			"[4/12] Chaque itinéraire est construit pour suivre le rythme des événements dynamiques.\n\nEn les enchaînant, vous découvrez le lore, vous croisez des PNJ intéressants, et vous explorez de manière fluide.\n\nOn peut facilement trouver le début d'un itinéraire en cochant les ''marqueurs initiaux'' dans le menu du pack. L'icone d'un marqueur initial est celle du marqueur actuellement affiché.",
			"[5/12] Que vous soyez un nouveau venu ou un vétéran, le MoW a quelque chose à vous offrir.\n\nDébutant ? Vous apprendrez à lire les cartes, développerez des reflexes d'exploration et vous vous familiariserez avec les mécaniques de jeu rapidement.\n\nExpérimenté ? Vous trouverez un terrain parfait pour des défis commne faire une chasse aux champions ou tenter de finir les guides sans mourrir.",
			"[6/12] Si c’est votre première utilisation du MoW, commencez par la Vallée de la Reine. Et si vous êtes nouveau joueur, continuez avec le Plateau de Diessa, ou laissez-vous guider par le pack.\n\nCe sont deux zones idéales pour comprendre la philosophie du pack, et vous familiariser avec le jeu.\n\nLes marqueurs vous fournissent parfois des infomations à COLLER (controle+C) dans votre chat. Passez au prochain marqueur pour essayez !",
			"[7/12] Le principe du pack est simple : trouver les marqueurs dans l’ordre, en suivant les indications.\n\nIls vous emmèneront d’un événement à l’autre, avec parfois des pauses ou des indications sur le lore, les mécaniques ou les PNJ à écouter.\n\nComparativement à une exploration libre vous gagnerez... Une meilleure compréhension du monde. Une exploration plus riche. Et souvent… des combats imprévus, des dialogues étonnants, ou des mécaniques que vous n’aviez jamais remarquées.",
			"[8/12] Chaque itinéraire du MoW est fait à la main, après des dizaines d’heures de repérage.\n\nLe pack est pensé pour être utilisé en affichant uniquement les marqueurs et en cachant les chemins. Néanmoins, si vous éprouvez des difficultés à suivres les indications, les chemins seront toujours à portée de main pour vous guider plus directement.\n\nLe pack peut être utilisé pour monter un personnage en niveau depuis une zone lvl 1-15 sans que cela ne pose problème.",
			"[9/12] La section MoW++ contient des marqueurs facultatifs. Notamment elle contient une section pour le lore, ainsi qu'une section pour les champions.",
			"[10/12] Les marqueurs pour les champions permettent de suivre un itinéraire débutant dans les Plaines d'Ashford et vous indicant tous les champions présents sur les maps successives.\n\nC'est l'idéal pour partir à la chasse et faire un peu de régulation de la faune locale!",
			"[11/12] ACTUELLEMENT, le MoW contient des guides pour: Le jeu de base, Sud-Soleil, les cartes de la Saison 2 du monde vivant, et les trois premières zones de HoT",
			"[12/12] Maintenant c'est à vous de profiter !\n\nPrenez votre temps. Observez, écoutez, explorez. Et surtout : laissez-vous porter par le mouvement du monde.\n\nPour fermer ce tutoriel, utilisez le menu des scripts en navigant depuis l'icone du pack de pathing de Blish-HUD (la petite tour)."
        },
        iconFile = { "MoW/MoW_Logo.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/mowstart.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/MoWLoreHGT.png", "MoW/MoWChampionListMaker.png", "MoW/MoWChampionMaker.png", "MoW/MoWTBW.png"},
        iconSize = { 1/3, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4 },
        copy = { "", "", "", "","","Commencez au [&BO8AAAA=], puis joignez le Plateau de Diessa depuis la Citadelle Noire pour entrer vers le [&BN4AAAA=]","","","","","" },
        copyMessage = "Message Copié",
        maxPages = 12,
		lang = "FR",
    },
	{
        info = {
            "[1/12] WELCOME TO THE MOVEMENT ON THE WORLD! Also known as the MoW.\n\nIf you're here, you're probably starting an exciting journey across Tyria (and beyond)! These first tutorial markers will help you understand how to use the guide and give you a few basics for surviving in this wild world you're about to explore.\n\nYou can move on to the next marker by pressing the interaction key to be configured in Blish-HUD (''F'' by default).",
            "[2/12] This guide offers a different way to explore the regions of Guild Wars 2, through the dynamic events, hidden dialogues and secrets of each zone.",
            "[3/12] The guide was created because Tyria's maps are full of life!\n\nThe World moves, the NPCs talk, and you... Well, you fight... But that's good too, isn't it?\n\nAnyway, a lot goes unnoticed. The MoW helps you see as much as possible!",
			"[4/12] Each itinerary is built to help keeping pace with dynamic events, so you can discover the lore, meet interesting NPCs and explore seamlessly.\n\nYou can easily find the start of an itinerary by checking the ''start markers'' in the pack menu.\n\nThe ''start marker'' icon is that of the marker currently displayed.",
			"[5/12] Whether you're a newcomer or a veteran, the MoW has something to offer you.\n\nNewcomer? You'll learn to read maps, develop exploration reflexes and quickly familiarize yourself with the game mechanics.\n\nExperienced? You'll find the perfect terrain for challenges such as hunting champions or trying a permadeath challenge while following the guides.",
			"[6/12] If you're new to MoW, start with Queensdale. And if you're a new GW2 player altogether, continue with the Diessa Plateau, or just let the pack guide you.\n\nThese are two ideal zones for understanding the pack's philosophy, and familiarizing yourself with the game.\n\nMarkers sometimes provide you with infomations to PASTE (control+C) into your chat. Move on to the next marker and give it a try!",
			"[7/12] The principle of the pack is simple: find the markers in the right order, following the indications.\n\nThey'll take you from one event to the next, with occasional pauses or information on lore, mechanics or NPCs to listen to.\n\nCompared to free exploration, you'll gain a better understanding of the World, richer exploration, and often... unexpected battles, surprising dialogues, or mechanics you'd never noticed before.",
			"[8/12] Each MoW route is hand-crafted, after dozens of hours of scouting.\n\nThe pack is designed to be used by displaying markers only and hiding paths. Nevertheless, should you have difficulty following the directions, the paths will always be at hand to guide you more directly.\n\nThe pack can be used to level up with a character starting in a lvl 1-15 zones without any issue.",
			"[9/12] The MoW++ section contains optional markers. In particular, it contains a section for lore, as well as a section for champions.",
			"[10/12] Champion markers allow you to follow an itinerary starting in the Plains of Ashford, pointing out to all the champions present on successive maps.\n\nIt's ideal to go hunting them all!",
			"[11/12] CURRENTLY, the MoW contains guides for: The core game, Southsun Cove, Living World Season 2 maps, and the first three zones of HoT",
			"[12/12] Now it's your turn to enjoy!\n\nTake your time. Observe, listen, explore. And above all: let yourself be carried by the movement on the World!\n\nTo close this tutorial, use the scripts menu by navigating from the Blish-HUD pathing pack icon (the small tower)."
        },
        iconFile = { "MoW/MoW_Logo.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/mowstart.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/MoWMakerBW.png", "MoW/MoWLoreHGT.png", "MoW/MoWChampionListMaker.png", "MoW/MoWChampionMaker.png", "MoW/MoWTBW.png"},
        iconSize = { 1/3, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4, 1/4 },
        copy = { "", "", "", "","","Start with exploring [&BO8AAAA=], then explore [&BN4AAAA=] entering the map from the Black Citadel","","","","","" },
        copyMessage = "Message Copied",
        maxPages = 12,
		lang = "EN",
    }
}

MoW.tutorial = {
    origin = nil,
    markerOffsets = {},
    pageTracker = { 1 },
    markers = {},
    shown = false
}

Debug:Watch("MoW_Tutorial", MoW.tutorial)

local function showTutorial(LANG)
    -- First we make the outer markers
    -- get angle between each marker
    local angle = 2 * math.pi / (MARKERS_IN_CIRCLE - 1)
    -- get player position as the origin
    MoW.tutorial.origin = Mumble.PlayerCharacter.Position

    for i = 1, MARKERS_IN_CIRCLE do
        --local theta = angle * i
        --local x = MARKER_DISTANCE_FROM_PLAYER * math.cos(theta)
        --local y = MARKER_DISTANCE_FROM_PLAYER * math.sin(theta)

        --if (i == MARKERS_IN_CIRCLE) then
		x = 0
		y = 0
        --end

		--Debug:Print("In MoW_ToggleTutorial, language is "..LANG) 
		if (MARKER_CATALOG[i].lang == LANG) then
			local attributes = {
				xpos = MoW.tutorial.origin.X + x,
				ypos = MoW.tutorial.origin.Z,
				zpos = MoW.tutorial.origin.Y + y,
				MapVisibility = false,
				InGameVisibility = true,
				Info = MARKER_CATALOG[i].info[1],
				iconSize = MARKER_CATALOG[i].iconSize[1],
				InfoRange = INFO_RANGE,
				type = MARKER_CATEGORY,
				copy = MARKER_CATALOG[i].copy[1],
				["copy-message"] = MARKER_CATALOG[i].copyMessage,
				["script-trigger"] = "MoW_Infoflip(" .. i .. ")"
			}

			local newMarker = Pack:CreateMarker(attributes)
			newMarker:SetTexture(MARKER_CATALOG[i].iconFile[1])
			table.insert(MoW.tutorial.markers, newMarker)
		end
    end

    MoW.tutorial.shown = true
end

local function hideTutorial()
    for _, marker in pairs(MoW.tutorial.markers) do
        marker:Remove()
    end

    MoW.tutorial.origin = nil
    MoW.tutorial.markerOffsets = {}
    MoW.tutorial.pageTracker = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }
    MoW.tutorial.markers = {}
    MoW.tutorial.shown = false
end

if (MoW_GetBool("firstLaunch")) then
    showTutorial("EN")
    MoW_ToggleStorage("firstLaunch")
end

function MoW_Infoflip(marker, autoTriggered, num)
    -- only do something if they actually pressed F
    if (autoTriggered == false) then
        -- Get catalog for the current marker
        local infoCatalog = MARKER_CATALOG[num]

        -- Get the new page
        local newPage = MoW.tutorial.pageTracker[num] + 1
        if (newPage > infoCatalog.maxPages) then newPage = 1 end

        -- Set new values to the new page
        marker:SetTexture(infoCatalog.iconFile[newPage])
        marker.Size = infoCatalog.iconSize[newPage]
        marker:GetBehavior("InfoModifier").InfoValue = infoCatalog.info[newPage]
        marker:GetBehavior("CopyModifier").CopyValue = infoCatalog.copy[newPage]

        MoW.tutorial.pageTracker[num] = newPage
    end
end

function MoW_ToggleTutorial(LANG)
    if (MoW.tutorial.shown) then
        hideTutorial()
    else
        showTutorial(LANG)
    end
end

function MoW_TutorialTickHandler(gametime)
    if (MoW.tutorial.shown) then
        if ((Mumble.PlayerCharacter.Position - MoW.tutorial.origin):Length() > 50) then
            hideTutorial()
        end
    end
end